var url_origen = 'http://www.alfafar.es';
var url_cita_previa = '/cita-previa-movil.php';
var url_sac = '/wp-content/plugins/lista_espera_sac/movil.php';

var url_sac_ayto = '/cita_previa_sac_casco_antiguo_movil/';
var url_sac_orba = '/cita-previa-sac-barrio-orba-movil/';

var pois = { 'bus': [], 'poi': [], 'parking': [], 'minusvalidos': [] };
var guia = {};
var gps;

var app = {

  initialize: function() {
    $('.volver').hide();
    this.bindMenu();
    this.bindEvents();
		this.bindCitaPrevia();
    this.getPois();
    this.getNoticias();
    this.getGuiaComercial();
    this.getEquipo();
  },

  // Bind Event Listeners
  //
  // Bind any events that are required on startup. Common events are:
  // 'load', 'deviceready', 'offline', and 'online'.
  bindEvents: function() {
    document.addEventListener('orientationchange', this.windowResize, false);
    document.addEventListener('deviceready', this.onDeviceReady, false);
    document.addEventListener('backbutton', this.onBackButton, false);
    $('#puntos_interes #gps_lock').click(gps_lock);
    $('#sugerencias #tomar_foto').click(getFotoSugerencia);
    $('#sugerencias #enviar_sugerencia').click(postSugerencia);
    $('#equipo .social').click(function(){ cordova.InAppBrowser.open($(this).attr('href'), '_system'); });
    $('.idioma').change(function(){ if($(this).val() != '') cambiar_idioma($(this).val()); });
    this.getSAC();
  },

  // deviceready Event Handler
  //
  // The scope of 'this' is the event. In order to call the 'receivedEvent'
  // function, we must explicitly call 'app.receivedEvent(...);'
  onDeviceReady: function() {
    navigator.geolocation.watchPosition(getGPS, function(){});
  },

  onBackButton: function(e){
    e.preventDefault();
    if($('.volver').css('display') != 'none') home();
    else navigator.app.exitApp();
  },

  bindMenu: function(){
    $('.volver').click(home);
    $('#menu .accion')
      .on('touchstart', function(){ $(this).addClass('activa'); })
      .on('touchend', function(){ $(this).removeClass('activa'); });
    $('#menu .accion[accion="web"]').click(web);
    $('#menu .accion[accion="puntos_interes"]').click(puntos_interes);
    $('#menu .accion[accion="equipo"]').click(equipo);
    $('#menu .accion[accion="noticias"]').click(noticias);
    $('#menu .accion[accion="guia_comercial"]').click(guia_comercial);
    $('#menu .accion[accion="sugerencias"]').click(sugerencias);
    $('#menu .accion[accion="cita_previa"]').click(cita_previa);
		$('#menu .accion[accion="sac_ayto"]').click(sac_ayto);
		$('#menu .accion[accion="sac_orba"]').click(sac_orba);
  },

	bindCitaPrevia: function(){
		preload_sac();
		$('#cita_previa .calendario.ayto').click(sac_ayto);
		$('#cita_previa .calendario.orba').click(sac_orba);
	},

  windowResize: function(){
    $('#puntos_interes').css('height', ($(window).height() - $('#cabecera').height()) + "px");
  },

  getPois: function(){
    $('#puntos_interes .poi input').change(mostrar_puntos_interes);
    $.getJSON(url_origen + '/api/maps/getPOI.php', function(data){ pois.poi = data; });
    $.getJSON(url_origen + '/api/maps/getTP.php', function(data){ pois.bus = data; });
    $.getJSON(url_origen + '/api/maps/getPARK.php', function(data){ pois.parking = data; });
    $.getJSON(url_origen + '/api/maps/getPARKMIN.php', function(data){ pois.minusvalidos = data; });
  },

  getNoticias: function(){
    $.getJSON(url_origen + '/jsonnoticias/?theme=active', function(data){
      var html = '';
      for(i=0; i<data.length; i++){
        html += '<div class="noticia" noticia="' + i + '"><p class="fecha">' + data[i].postDate + '</p><h3>' + data[i].postName + '</h3><p class="resumen">' + data[i].postExcerpt + '</p><div class="detalle">' + data[i].postContent + '</div><a class="leer_mas t" t="ampliar_noticia">Ampliar noticia</a></div>';
      }
      $('#noticias .contenido_noticias').html(html);
      $('#noticias .leer_mas').click(function(){
        var noticia = $(this).parent().attr('noticia');
        $(this).hide();
        $('#noticias .noticia[noticia="' + noticia + '"] .resumen').hide();
        $('#noticias .noticia[noticia="' + noticia + '"] .detalle').show();
      });
    }).fail(function(){
      setTimeout('app.getNoticias();', 3000);
    });
  },

  getSAC: function(){
    $.getJSON(url_origen + url_sac, function(data){
      if(data.estado == 'ok'){
        $('.cola.sac.casco_antiguo').html(data.casco_antiguo);
        $('.cola.sac.barrio_orba').html(data.barrio_orba);
      } else $('.cola.sac').html('-');
    }).fail(function(){
      $('.cola.sac').html('-');
    });
    setTimeout('app.getSAC();', 60000);
  },

  getGuiaComercial: function(){

		if(localStorage.getItem('guia_comercial') === null) setTimeout(downloadGuiaComercial, 500);
		else {
			cargarGuiaComercial();
			setTimeout(downloadGuiaComercial, 5000);
		}

		/*
    $.getJSON(url_origen + '/jsongetcategorias/?theme=active', function(categorias){
      $('#guia_comercial .contenido_guia_comercial').html('');
      for(i=0; i<categorias.length; i++){
        if($.trim(categorias[i].catName) != ''){
          guia[categorias[i].catName] = [];
          $('#guia_comercial .contenido_guia_comercial').append('<div class="categoria" categoria="' + categorias[i].catName + '"><h3>' + categorias[i].catName +  '<i class="toggle fa fa-plus-square-o"></i></h3><div class="inner row"><p class="cargando">Cargando...</p></div></div>');
          $.getJSON(url_origen + '/jsongetitemsbycategory/?cat=' + categorias[i].catName + '&theme=active', function(comercios){
            for(j=0; j<comercios.length; j++){
              $('#guia_comercial .contenido_guia_comercial .categoria[categoria="' + comercios[j].catName + '"] .cargando').remove();
              guia[comercios[j].catName].push(comercios[j]);
              if(typeof comercios[j].imagen != 'undefined' && comercios[j].imagen != '') imagen = comercios[j].imagen; else imagen = 'img/sin_foto.png';
              $('#guia_comercial .contenido_guia_comercial .categoria[categoria="' + comercios[j].catName + '"] .inner').append('<div class="comercio col-xs-6 col-md-4" comercio="' + j + '"><img xsrc="' + imagen + '" class="unload"><br/>' + comercios[j].titulo + '</div');
              $('#guia_comercial .contenido_guia_comercial .categoria[categoria="' + comercios[j].catName + '"] .inner .comercio').unbind('click').bind('click', mostrar_comercio);
              if(j%2 == 1) $('#guia_comercial .contenido_guia_comercial .categoria[categoria="' + comercios[j].catName + '"] .inner').append('<div class="clear"></div>');
            }
          });
        }
      }
      $('#guia_comercial .contenido_guia_comercial .categoria .toggle').click(function(){
        var c = $(this).parent().parent().attr('categoria');
        if($(this).hasClass('fa-plus-square-o')){
          $(this).removeClass('fa-plus-square-o');
          $(this).addClass('fa-minus-square-o');
					$('div.categoria[categoria="' + c + '"] img.unload').each(function(){
						$(this).attr('src', $(this).attr('xsrc'));
						$(this).removeClass('unload');
					});
        } else {
          $(this).removeClass('fa-minus-square-o');
          $(this).addClass('fa-plus-square-o');
        }
        $('#guia_comercial .contenido_guia_comercial .categoria[categoria="' + c +'"] .inner').toggle();
      });
    }).fail(function(){
      setTimeout('app.getGuiaComercial();', 3000);
    });
		*/
  },

  getEquipo: function(){
    $.getJSON(url_origen + '/api/gobierno/getConcejal.php', function(concejales){
      var html = '';
      for(i=0; i<concejales.length; i++){
        if(i>0) html += '<hr>';
        html += '<div class="concejal col-xs-12"><img src="' + concejales[i].Imagen + '"><h4>' + concejales[i].Nombre + '</h4><p class="descripcion">' + concejales[i].Descripcion + '</p></div>';
      }
      $('#equipo .contenido_equipo').html(html.replace(/\n/g, '</p><p>'));
    }).fail(function(){
      setTimeout('app.getEquipo();', 3000);
    });
  },

};

function home(){
  $('.pagina:not(#menu)').fadeOut();
  $('#menu').fadeIn();
  $('.volver').hide();
}

function web(){
  cordova.InAppBrowser.open(url_origen, '_system');
}

function preload_sac(){
	setTimeout(function(){ $('#cita_previa iframe.ayto').attr('src', url_origen + url_sac_ayto); }, 500);
	setTimeout(function(){ $('#cita_previa iframe.orba').attr('src', url_origen + url_sac_orba); }, 500);
}

function sac_ayto(){
	$('#cita_previa').css('height', ($(window).height() - $('#cabecera').height()) + "px");
  //$('#cita_previa iframe').attr('src', 'cargando.html');
  //setTimeout(function(){ $('#cita_previa iframe').attr('src', url_origen + url_sac_ayto); }, 500);

	$('#cita_previa iframe.ayto').show();
	$('#cita_previa iframe.orba').hide();
	$('#cita_previa .opciones').hide();

	$('#cita_previa').show();
  $('#menu').hide();
  $('.volver').show();
}

function sac_orba(){
	$('#cita_previa').css('height', ($(window).height() - $('#cabecera').height()) + "px");
  //$('#cita_previa iframe').attr('src', 'cargando.html');
  //setTimeout(function(){ $('#cita_previa iframe').attr('src', url_origen + url_sac_orba); }, 500);

	$('#cita_previa iframe.ayto').hide();
	$('#cita_previa iframe.orba').show();
	$('#cita_previa .opciones').hide();

  $('#cita_previa').show();
  $('#menu').hide();
  $('.volver').show();
}

function cita_previa(){

  //cordova.InAppBrowser.open(url_origen + url_cita_previa, '_system');
	/*
  $('#cita_previa').css('height', ($(window).height() - $('#cabecera').height()) + "px");
  $('#cita_previa iframe').attr('src', 'cargando.html');
  setTimeout(function(){ $('#cita_previa iframe').attr('src', url_origen + url_cita_previa); }, 500);
	*/

	$('#cita_previa iframe').hide();
	$('#cita_previa .opciones').show();

  $('#cita_previa').show();
  $('#menu').hide();
  $('.volver').show();

}

function getGPS(position){
  gps = position;
  $('#sugerencias .progress').removeClass('active');
  $('#sugerencias .progress .progress-bar').removeClass('progress-bar-warning').addClass('progress-bar-success');
  $('#sugerencias .info_gps').html(_t('gps_fijado'));
  $('#sugerencias .info_gps').attr('t', 'gps_fijado');
  if(typeof my_marker != 'undefined'){ // actualizar mi posicion
    var coordenada = new google.maps.LatLng(parseFloat(gps.coords.latitude), parseFloat(gps.coords.longitude));
    if(typeof my_marker != 'undefined') my_marker.setPosition(coordenada);
    if(typeof mapa_poi != 'undefined' && gps_locked) mapa_poi.setCenter(coordenada);
  }
}

function downloadGuiaComercial(){
	$.getJSON(url_origen + '/jsongetcategorias2/', function(guia_comercial){
		localStorage.setItem('guia_comercial', JSON.stringify(guia_comercial));
		cargarGuiaComercial();
	}).fail(function(){
		setTimeout('downloadGuiaComercial();', 5000);
	});
}

function cargarGuiaComercial(){

	guia = {};
	var categorias = JSON.parse(localStorage.getItem('guia_comercial'));
	$('#guia_comercial .contenido_guia_comercial').html('');

	for(i=0; i<categorias.length; i++){
		if($.trim(categorias[i].catName) != ''){
			guia[categorias[i].catName] = [];
			$('#guia_comercial .contenido_guia_comercial').append('<div class="categoria" categoria="' + categorias[i].catName + '"><h3>' + categorias[i].catName +  '<i class="toggle fa fa-plus-square-o"></i></h3><div class="inner row"><p class="cargando">Cargando...</p></div></div>');
			var comercios = categorias[i].items;
			for(j=0; j<comercios.length; j++){
				$('#guia_comercial .contenido_guia_comercial .categoria[categoria="' + comercios[j].catName + '"] .cargando').remove();
				guia[comercios[j].catName].push(comercios[j]);
				if(typeof comercios[j].imagen != 'undefined' && comercios[j].imagen != '') imagen = comercios[j].imagen; else imagen = 'img/sin_foto.png';
				$('#guia_comercial .contenido_guia_comercial .categoria[categoria="' + comercios[j].catName + '"] .inner').append('<div class="comercio col-xs-6 col-md-4" comercio="' + j + '"><img xsrc="' + imagen + '" class="unload"><br/>' + comercios[j].titulo + '</div');
				$('#guia_comercial .contenido_guia_comercial .categoria[categoria="' + comercios[j].catName + '"] .inner .comercio').unbind('click').bind('click', mostrar_comercio);
				if(j%2 == 1) $('#guia_comercial .contenido_guia_comercial .categoria[categoria="' + comercios[j].catName + '"] .inner').append('<div class="clear"></div>');
			}
		}
	}

	$('#guia_comercial .contenido_guia_comercial .categoria .toggle').click(function(){
		var c = $(this).parent().parent().attr('categoria');
		if($(this).hasClass('fa-plus-square-o')){
			$(this).removeClass('fa-plus-square-o');
			$(this).addClass('fa-minus-square-o');
			$('div.categoria[categoria="' + c + '"] img.unload').each(function(){
				$(this).attr('src', $(this).attr('xsrc'));
				$(this).removeClass('unload');
			});
		} else {
			$(this).removeClass('fa-minus-square-o');
			$(this).addClass('fa-plus-square-o');
		}
		$('#guia_comercial .contenido_guia_comercial .categoria[categoria="' + c +'"] .inner').toggle();
	});

}

var mapa_poi;
var my_marker;
function puntos_interes(){
  if(typeof mapa_poi == 'undefined'){
    var opciones = {
      center: new google.maps.LatLng(39.417190, -0.400059),
      zoom: 15,
      disableDefaultUI: true,
      mapTypeId: google.maps.MapTypeId.ROADMAP
    };
    mapa_poi = new google.maps.Map(document.getElementById("mapa"), opciones);
    my_marker = new google.maps.Marker({
      position: new google.maps.LatLng(39.417190, -0.400059),
      map: mapa_poi,
      icon: 'img/posicion.png',
      visible: false
    });
  }
  mostrar_puntos_interes();
  $('#puntos_interes').css('height', ($(window).height() - $('#cabecera').height()) + "px");
  $('#puntos_interes').show();
  $('#menu').hide();
  $('.volver').show();
}

var markers = [];
function mostrar_puntos_interes(){
  for(i=0; i<markers.length; i++) markers[i].setMap(null); markers = [];
  if($('#puntos_interes .poi input[name="poi"]').is(':checked')){
    for(i=0; i<pois.poi.length; i++) mostrar_punto_interes(pois.poi[i], 'poi');
  }
  if($('#puntos_interes .poi input[name="bus"]').is(':checked')){
    for(i=0; i<pois.bus.length; i++) mostrar_punto_interes(pois.bus[i], 'bus');
  }
  if($('#puntos_interes .poi input[name="parking"]').is(':checked')){
    for(i=0; i<pois.parking.length; i++) mostrar_punto_interes(pois.parking[i], 'parking');
  }
  if($('#puntos_interes .poi input[name="minusvalidos"]').is(':checked')){
    for(i=0; i<pois.minusvalidos.length; i++) mostrar_punto_interes(pois.minusvalidos[i], 'minusvalidos');
  }
}

function mostrar_punto_interes(punto, tipo){
  if(typeof mapa_poi != 'undefined'){
    var _marker = new google.maps.Marker({
      position: new google.maps.LatLng(parseFloat(punto.Lat), parseFloat(punto.Lon)),
      map: mapa_poi,
      icon: 'img/poi_' + tipo + '_marker.png',
      title: punto.Titulo
    });
    if(punto.Descripcion != ''){
      var infowindow = new google.maps.InfoWindow({ maxWidth: $('body').width() - 10 });
      var descripcion = '<h3>' + punto.Titulo + '</h3><p>' + punto.Descripcion + '</p>';
      google.maps.event.addListener(_marker, 'click', (function (marker, content, infowindow){
        return function () {
          infowindow.setContent(content);
          infowindow.open(mapa_poi, marker);
        };
      })(_marker, descripcion, infowindow));
    }
    markers.push(_marker);
  }
}

var gps_locked = false;
function gps_lock(){
  gps_locked = !gps_locked;
  if(gps_locked){
    $('#puntos_interes #gps_lock').attr('src', 'img/gps_locked.png');
    if(typeof my_marker != 'undefined') my_marker.setVisible(true);
    if(typeof gps != 'undefined'){
      var coordenada = new google.maps.LatLng(parseFloat(gps.coords.latitude), parseFloat(gps.coords.longitude));
      if(typeof my_marker != 'undefined') my_marker.setPosition(coordenada);
      if(typeof mapa_poi != 'undefined') mapa_poi.setCenter(coordenada);
    }
  } else {
    $('#puntos_interes #gps_lock').attr('src', 'img/gps_unlocked.png');
    if(typeof my_marker != 'undefined') my_marker.setVisible(false);
  }
}

function equipo(){
  $('#equipo').fadeIn();
  $('#menu').fadeOut();
  $('.volver').show();
}

function noticias(){
  $('#noticias').fadeIn();
  $('#menu').fadeOut();
  $('.volver').show();
}

function guia_comercial(){
  $('#guia_comercial').fadeIn();
  $('#menu').fadeOut();
  $('.volver').show();
}

function mostrar_comercio(){

  var c = $(this).parent().parent().attr('categoria');
  var id = $(this).attr('comercio');
  var comercio = guia[c][id];

  var imagen = 'img/sin_foto.png';
  if(typeof comercio.imagen != 'undefined' && comercio.imagen != '') imagen = comercio.imagen;

  var html = '<img src="' + imagen + '"><p class="info">';
  if(typeof comercio.direccion != 'undefined' && comercio.direccion != '') html += '<span class="direccion">' + _t('direccion') + '</span>' + comercio.direccion;
  if(typeof comercio.horario != 'undefined' && comercio.horario != '') html += '<span class="horario">' + _t('horario') + '</span>' + comercio.horario;
  if(typeof comercio.telefono != 'undefined' && comercio.telefono != '') html += '<span class="telefono">' + _t('telefono') + '</span>' + comercio.telefono;
  if(typeof comercio.web != 'undefined' && comercio.web != '') html += '<span class="web">' + _t('web') + '</span>' + comercio.web;
  if(typeof comercio.correo != 'undefined' && comercio.correo != '') html += '<span class="correo">' + _t('correo') + '</span>' + comercio.correo;
  html += '</p>';

  $('#guia_comercial .modal .modal-title').html(comercio.titulo);
  $('#guia_comercial .modal .modal-body').html(html);
  $('#guia_comercial .modal').modal('show');
  $('#guia_comercial .modal').unbind('click').bind('click', function(){ $('#guia_comercial .modal').modal('hide'); });

}

function sugerencias(){
  $('#sugerencias input, #sugerencias textarea').val('');
  $('#sugerencias #foto').attr('src', '');
  $('#sugerencias #foto').hide();
  $('#sugerencias .cargando').hide();
  $('#sugerencias').fadeIn();
  $('#menu').fadeOut();
  $('.volver').show();
}

function getFotoSugerencia(){
  navigator.camera.getPicture(
    function(data){
      $('#sugerencias #foto').attr('src', 'data:image/jpeg;base64,' + data);
      $('#sugerencias #foto').show();
    },
    function(){},
    {
      destinationType: 0, // DATA_URL
      encodingType: 0, // JPG
      quality: 60,
      targetWidth: 800,
      targetHeigth: 800,
      allowEdit: false,
      correctOrientation: true,
      saveToPhotoAlbum: false,
    }
  );
}

function postSugerencia(){
  var email = $('#sugerencias #email').val();
  var mensaje = $('#sugerencias #mensaje').val();
  var foto = $('#sugerencias #foto').attr('src');
  if(!validar_email(email)){ alerta(_t('correo_invalido')); return false; }
  if(typeof gps == 'undefined'){ alerta(_t('sin_gps')); return false; }
  if(mensaje == '' && foto == ''){ alerta(_t('sin_mensaje')); return false; }
  $('#enviar_sugerencia').hide();
  $('#sugerencias .cargando').show();
  $.post(
    url_origen + '/api/sendIncidencia.php',
    {lat: gps.coords.latitude, lon: gps.coords.longitude, mail: email, incidencia: mensaje, imagen: foto},
    function(msg){
      if(msg == 'ok'){
        alerta(_t('incidencia_enviada'), 'OK');
        home();
      } else {
        alerta(_t('error_enviando_incidencia'));
      }
    }
  ).fail(function(){
    alerta(_t('error_enviando_incidencia'));
  }).always(function(){
    $('#sugerencias .cargando').hide();
    $('#enviar_sugerencia').show();
  });
}

function validar_email(email){
	return (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,4})+$/.test(email));
}

function alerta(texto, titulo){
  if(typeof titulo == 'undefined') titulo = 'Error';
  navigator.notification.alert(texto, function(){}, titulo, _t('cerrar'));
}

app.initialize();
